// token.cpp generated by reflex 3.3.5 from token.l

#define REFLEX_VERSION "3.3.5"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  OPTIONS USED                                                              //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#define REFLEX_OPTION_flex                false
#define REFLEX_OPTION_header_file         "token.h"
#define REFLEX_OPTION_lex                 lex
#define REFLEX_OPTION_lexer               Lexer
#define REFLEX_OPTION_never_interactive   true
#define REFLEX_OPTION_noyywrap            true
#define REFLEX_OPTION_outfile             "token.cpp"
#define REFLEX_OPTION_prefix              yy

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  SECTION 1: %top user code                                                 //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#line 1 "token.l"

  #include <stdlib.h>
  #include <iostream>
  #include <iomanip>
  #include <vector>
  #include <map>


////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  FLEX-COMPATIBLE DEFINITIONS                                               //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#define INITIAL (0)
#define YY_NUM_RULES (64)

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  LEXER CLASS INCLUDE                                                       //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#include "token.h"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  SECTION 1: %{ user code %}                                                //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#line 8 "token.l"

#include "token_enum.h"


////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  SECTION 2: rules                                                          //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

int Lexer::lex(void)
{
  static const char *REGEX_INITIAL = "(?m)(0[0-7]+)|([0-9]+)|([0-9]*\\.[0-9]+)|([0-9]*\\.[0-9]+[Ee][\\x2b\\x2d][0-9]*)|(0[Xx][0-9A-Fa-f]+)|(0[Bb][01]+)|('[^\\x5c]+')|('\\\\[\"'0abfnrtv]')|('\\\\[0-7]+')|('\\\\x[0-9A-Fa-f]+')|(\"(?:[^\"\\x5c]|\\\\.)*\")|(\\$[A-Z_a-z][0-9A-Z_a-z]*)|([A-Z_a-z][0-9A-Z_a-z]*)|([A-Z_a-z][0-9A-Z_a-z]*[\\x09\\x20]*\\()|(//)|(<<=)|(>>=)|(\\+\\+)|(--)|(<<)|(>>)|(<=)|(>=)|(==)|(!=)|(&&)|(\\|\\|)|(\\*=)|(/=)|(%=)|(\\+=)|(-=)|(&=)|(\\|=)|(\\^=)|(-)|(\\+)|(\\*)|(/)|(%)|(<)|(>)|(\\^)|(\\|)|(@)|(&)|(=)|(~)|(!)|(\\?)|(:)|(\\()|(\\))|(\\[)|(\\])|(\\{)|(\\})|(;)|(,)|(/\\*)|(\\*/)|(#)|(\\s)|(.)";
  static const reflex::Pattern PATTERN_INITIAL(REGEX_INITIAL);
  if (!has_matcher())
  {
    matcher(new Matcher(PATTERN_INITIAL, stdinit(), this));
    YY_USER_INIT
  }
  while (true)
  {
        switch (matcher().scan())
        {
          case 0:
            if (matcher().at_end())
            {
              yyterminate();
            }
            else
            {
              output(matcher().input());
            }
            YY_BREAK
          case 1: // rule token.l:15: 0[0-7]+ :
            YY_USER_ACTION
#line 15 "token.l"
{ return(OCTAL_TOK); }
            YY_BREAK
          case 2: // rule token.l:16: [0-9]+ :
            YY_USER_ACTION
#line 16 "token.l"
{ return(INTEGER_TOK); }
            YY_BREAK
          case 3: // rule token.l:17: [0-9]*\.[0-9]+ :
            YY_USER_ACTION
#line 17 "token.l"
{ return(FLOAT_TOK); }
            YY_BREAK
          case 4: // rule token.l:18: [0-9]*\.[0-9]+[Ee][+-][0-9]* :
            YY_USER_ACTION
#line 18 "token.l"
{ return(FLOAT_TOK); }
            YY_BREAK
          case 5: // rule token.l:19: 0[xX][0-9a-fA-F]+ :
            YY_USER_ACTION
#line 19 "token.l"
{ return(HEX_TOK); }
            YY_BREAK
          case 6: // rule token.l:20: 0[bB][01]+ :
            YY_USER_ACTION
#line 20 "token.l"
{ return(BIN_TOK); }
            YY_BREAK
          case 7: // rule token.l:21: '[^\\]+' :
            YY_USER_ACTION
#line 21 "token.l"
{ return(CHAR_TOK); }
            YY_BREAK
          case 8: // rule token.l:22: '\\[0abfnrtv'\"]' :
            YY_USER_ACTION
#line 22 "token.l"
{ return(CTRL_CHAR_TOK); }
            YY_BREAK
          case 9: // rule token.l:23: '\\[0-7]+' :
            YY_USER_ACTION
#line 23 "token.l"
{ return(OCT_CHAR_TOK); }
            YY_BREAK
          case 10: // rule token.l:24: '\\x[0-9a-fA-F]+' :
            YY_USER_ACTION
#line 24 "token.l"
{ return(HEX_CHAR_TOK); }
            YY_BREAK
          case 11: // rule token.l:25: \"([^\"\\]|\\.)*\" :
            YY_USER_ACTION
#line 25 "token.l"
{ return(STRING_CONST_TOK); }
            YY_BREAK
          case 12: // rule token.l:26: \$[a-zA-Z_][a-zA-Z0-9_]* :
            YY_USER_ACTION
#line 26 "token.l"
{ return(SHELL_VARIABLE_TOK); }
            YY_BREAK
          case 13: // rule token.l:27: [a-zA-Z_][a-zA-Z0-9_]* :
            YY_USER_ACTION
#line 27 "token.l"
{ return(VARIABLE_TOK); }
            YY_BREAK
          case 14: // rule token.l:28: [a-zA-Z_][a-zA-Z0-9_]*[ \t]*\( :
            YY_USER_ACTION
#line 28 "token.l"
{ return(FUNCTION_TOK); }
            YY_BREAK
          case 15: // rule token.l:29: \/\/ :
            YY_USER_ACTION
#line 29 "token.l"
{ return(COMMENT_TOK); }
            YY_BREAK
          case 16: // rule token.l:30: <<= :
            YY_USER_ACTION
#line 30 "token.l"
{ return(SH_LEFT_ASSIGN_TOK); }
            YY_BREAK
          case 17: // rule token.l:31: >>= :
            YY_USER_ACTION
#line 31 "token.l"
{ return(SH_RIGHT_ASSIGN_TOK); }
            YY_BREAK
          case 18: // rule token.l:32: \+\+ :
            YY_USER_ACTION
#line 32 "token.l"
{ return(POST_INC_TOK); }
            YY_BREAK
          case 19: // rule token.l:33: -- :
            YY_USER_ACTION
#line 33 "token.l"
{ return(POST_DEC_TOK); }
            YY_BREAK
          case 20: // rule token.l:34: << :
            YY_USER_ACTION
#line 34 "token.l"
{ return(SHIFT_LEFT_TOK); }
            YY_BREAK
          case 21: // rule token.l:35: >> :
            YY_USER_ACTION
#line 35 "token.l"
{ return(SHIFT_RIGHT_TOK); }
            YY_BREAK
          case 22: // rule token.l:36: <= :
            YY_USER_ACTION
#line 36 "token.l"
{ return(LESS_EQUAL_TOK); }
            YY_BREAK
          case 23: // rule token.l:37: >= :
            YY_USER_ACTION
#line 37 "token.l"
{ return(GREATER_EQUAL_TOK); }
            YY_BREAK
          case 24: // rule token.l:38: == :
            YY_USER_ACTION
#line 38 "token.l"
{ return(EQUAL_TOK); }
            YY_BREAK
          case 25: // rule token.l:39: != :
            YY_USER_ACTION
#line 39 "token.l"
{ return(NOT_EQUAL_TOK); }
            YY_BREAK
          case 26: // rule token.l:40: && :
            YY_USER_ACTION
#line 40 "token.l"
{ return(AND_TOK); }
            YY_BREAK
          case 27: // rule token.l:41: \|\| :
            YY_USER_ACTION
#line 41 "token.l"
{ return(OR_TOK); }
            YY_BREAK
          case 28: // rule token.l:42: \*= :
            YY_USER_ACTION
#line 42 "token.l"
{ return(MUL_ASSIGN_TOK); }
            YY_BREAK
          case 29: // rule token.l:43: \/= :
            YY_USER_ACTION
#line 43 "token.l"
{ return(DIV_ASSIGN_TOK); }
            YY_BREAK
          case 30: // rule token.l:44: %= :
            YY_USER_ACTION
#line 44 "token.l"
{ return(MOD_ASSIGN_TOK); }
            YY_BREAK
          case 31: // rule token.l:45: \+= :
            YY_USER_ACTION
#line 45 "token.l"
{ return(ADD_ASSIGN_TOK); }
            YY_BREAK
          case 32: // rule token.l:46: \-= :
            YY_USER_ACTION
#line 46 "token.l"
{ return(SUB_ASSIGN_TOK); }
            YY_BREAK
          case 33: // rule token.l:47: &= :
            YY_USER_ACTION
#line 47 "token.l"
{ return(AND_ASSIGN_TOK); }
            YY_BREAK
          case 34: // rule token.l:48: \|= :
            YY_USER_ACTION
#line 48 "token.l"
{ return(OR_ASSIGN_TOK); }
            YY_BREAK
          case 35: // rule token.l:49: \^= :
            YY_USER_ACTION
#line 49 "token.l"
{ return(XOR_ASSIGN_TOK); }
            YY_BREAK
          case 36: // rule token.l:50: - :
            YY_USER_ACTION
#line 50 "token.l"
{ return(UNARY_MINUS_TOK); }
            YY_BREAK
          case 37: // rule token.l:51: \+ :
            YY_USER_ACTION
#line 51 "token.l"
{ return(UNARY_PLUS_TOK); }
            YY_BREAK
          case 38: // rule token.l:52: \* :
            YY_USER_ACTION
#line 52 "token.l"
{ return(MULTIPLY_TOK); }
            YY_BREAK
          case 39: // rule token.l:53: \/ :
            YY_USER_ACTION
#line 53 "token.l"
{ return(DIVIDE_TOK); }
            YY_BREAK
          case 40: // rule token.l:54: % :
            YY_USER_ACTION
#line 54 "token.l"
{ return(MODULO_TOK); }
            YY_BREAK
          case 41: // rule token.l:55: < :
            YY_USER_ACTION
#line 55 "token.l"
{ return(LESS_TOK); }
            YY_BREAK
          case 42: // rule token.l:56: > :
            YY_USER_ACTION
#line 56 "token.l"
{ return(GREATER_TOK); }
            YY_BREAK
          case 43: // rule token.l:57: \^ :
            YY_USER_ACTION
#line 57 "token.l"
{ return(BIT_XOR_TOK); }
            YY_BREAK
          case 44: // rule token.l:58: \| :
            YY_USER_ACTION
#line 58 "token.l"
{ return(BIT_OR_TOK); }
            YY_BREAK
          case 45: // rule token.l:59: @ :
            YY_USER_ACTION
#line 59 "token.l"
{ return(ATSIGN_TOK); }
            YY_BREAK
          case 46: // rule token.l:60: & :
            YY_USER_ACTION
#line 60 "token.l"
{ return(BIT_AND_TOK); }
            YY_BREAK
          case 47: // rule token.l:61: = :
            YY_USER_ACTION
#line 61 "token.l"
{ return(ASSIGN_TOK); }
            YY_BREAK
          case 48: // rule token.l:62: ~ :
            YY_USER_ACTION
#line 62 "token.l"
{ return(COMPLEMENT_TOK); }
            YY_BREAK
          case 49: // rule token.l:63: ! :
            YY_USER_ACTION
#line 63 "token.l"
{ return(NOT_TOK); }
            YY_BREAK
          case 50: // rule token.l:64: \? :
            YY_USER_ACTION
#line 64 "token.l"
{ return(QUESTION_TOK); }
            YY_BREAK
          case 51: // rule token.l:65: : :
            YY_USER_ACTION
#line 65 "token.l"
{ return(COLON_TOK); }
            YY_BREAK
          case 52: // rule token.l:66: \( :
            YY_USER_ACTION
#line 66 "token.l"
{ return(OPEN_PAREN_TOK); }
            YY_BREAK
          case 53: // rule token.l:67: \) :
            YY_USER_ACTION
#line 67 "token.l"
{ return(CLOSE_PAREN_TOK); }
            YY_BREAK
          case 54: // rule token.l:68: \[ :
            YY_USER_ACTION
#line 68 "token.l"
{ return(OPEN_BRACE_TOK); }
            YY_BREAK
          case 55: // rule token.l:69: \] :
            YY_USER_ACTION
#line 69 "token.l"
{ return(CLOSE_BRACE_TOK); }
            YY_BREAK
          case 56: // rule token.l:70: \{ :
            YY_USER_ACTION
#line 70 "token.l"
{ return(OPEN_BRACKET_TOK); }
            YY_BREAK
          case 57: // rule token.l:71: \} :
            YY_USER_ACTION
#line 71 "token.l"
{ return(CLOSE_BRACKET_TOK); }
            YY_BREAK
          case 58: // rule token.l:72: ; :
            YY_USER_ACTION
#line 72 "token.l"
{ return(SEMICOLON_TOK); }
            YY_BREAK
          case 59: // rule token.l:73: , :
            YY_USER_ACTION
#line 73 "token.l"
{ return(COMMA_TOK); }
            YY_BREAK
          case 60: // rule token.l:74: \/\* :
            YY_USER_ACTION
#line 74 "token.l"
{ return(OPEN_COMMENT_TOK); }
            YY_BREAK
          case 61: // rule token.l:75: \*\/ :
            YY_USER_ACTION
#line 75 "token.l"
{ return(CLOSE_COMMENT_TOK); }
            YY_BREAK
          case 62: // rule token.l:76: # :
            YY_USER_ACTION
#line 76 "token.l"
{ return(COMMENT_TOK); }
            YY_BREAK
          case 63: // rule token.l:77: \s :
            YY_USER_ACTION
#line 77 "token.l"
{ return(WHITE_SPACE_TOK); }
            YY_BREAK
          case 64: // rule token.l:78: . :
            YY_USER_ACTION
#line 78 "token.l"
{ return(ERROR_TOK); }

            YY_BREAK
        }
  }
}
