#ifndef _token_enum_h_
#define _token_enum_h_

enum TOKEN {
    ERROR_TOK            = 0,
    INTEGER_TOK          = 1,
    FLOAT_TOK            = 2,
    OCTAL_TOK            = 3,
    HEX_TOK              = 4,
    BIN_TOK              = 5,
    CHAR_TOK             = 6,
    CTRL_CHAR_TOK        = 7,
    OCT_CHAR_TOK         = 8,
    HEX_CHAR_TOK         = 9,
    STRING_CONST_TOK     = 10,
    VARIABLE_TOK         = 11,
    SHELL_VARIABLE_TOK   = 12,
    FUNCTION_TOK         = 13,
    OPEN_PAREN_TOK       = 14,
    CLOSE_PAREN_TOK      = 15,
    POST_INC_TOK         = 16,
    PRE_INC_TOK          = 17,
    POST_DEC_TOK         = 18,
    PRE_DEC_TOK          = 19,
    COMPLEMENT_TOK       = 20,
    NOT_TOK              = 21,
    UNARY_MINUS_TOK      = 22,
    UNARY_PLUS_TOK       = 23,
    MULTIPLY_TOK         = 24,
    DIVIDE_TOK           = 25,
    MODULO_TOK           = 26,
    ADD_TOK              = 27,
    SUBTRACT_TOK         = 28,
    SHIFT_LEFT_TOK       = 29,
    SHIFT_RIGHT_TOK      = 30,
    LESS_TOK             = 31,
    LESS_EQUAL_TOK       = 32,
    GREATER_TOK          = 33,
    GREATER_EQUAL_TOK    = 34,
    EQUAL_TOK            = 35,
    NOT_EQUAL_TOK        = 36,
    ATSIGN_TOK           = 37,
    BIT_AND_TOK          = 38,
    BIT_XOR_TOK          = 39,
    BIT_OR_TOK           = 40,
    AND_TOK              = 41,
    OR_TOK               = 42,
    QUESTION_TOK         = 43,
    COLON_TOK            = 44,
    ASSIGN_TOK           = 45,
    MUL_ASSIGN_TOK       = 46,
    DIV_ASSIGN_TOK       = 47,
    MOD_ASSIGN_TOK       = 48,
    ADD_ASSIGN_TOK       = 49,
    SUB_ASSIGN_TOK       = 50,
    SH_LEFT_ASSIGN_TOK   = 51,
    SH_RIGHT_ASSIGN_TOK  = 52,
    AND_ASSIGN_TOK       = 53,
    OR_ASSIGN_TOK        = 54,
    XOR_ASSIGN_TOK       = 55,
    OPEN_BRACE_TOK       = 56,
    CLOSE_BRACE_TOK      = 57,
    OPEN_BRACKET_TOK     = 58,
    CLOSE_BRACKET_TOK    = 59,
    SEMICOLON_TOK        = 60,
    COMMA_TOK            = 61,
    COMMENT_TOK          = 62,
    OPEN_COMMENT_TOK     = 63,
    CLOSE_COMMENT_TOK    = 64,
    VALUE_TOK            = 65,
    FILE_TOK             = 66,
    OUTFILE_TOK          = 67,
    INFILE_TOK           = 68,
    BUILTIN_FUNCTION_TOK = 69,
    CONTROL_FUNCTION_TOK = 70,
    BUILTIN_TYPE_TOK     = 71,
    MAIN_FUNCTION_TOK    = 72,
    WHITE_SPACE_TOK      = 73,
    NOP_TOK              = 74,
    EOF_TOK              = 75
};

#endif /* _token_enum_h_ */
